---
title: Add Animation to Survey Elements
product: Form Library
description: SurveyJS supplies highly customizable editing tools that let you create surveys and forms. Apart from personalized elements, such as a logo, custom survey title, and description, you can enable form animation. Apply motion, fading, sliding, and other types of animation effects to form elements or the entire form. View this free code example for JavaScript to learn more.
framework: Vanilla JS
source: https://surveyjs.io/form-library/examples/add-animation-effects-to-form-elements/vanillajs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Add Animation to Survey Elements (Vanilla JS)

Form animation refers to the use of dynamic and interactive visual effects and transitions that enhance usability, guide users through a form, and create a more enjoyable form-filling experience. A survey creator can apply motion, fading, sliding, and other types of animation effects to individual form elements or the entire form, as shown in this demo. Switch between survey pages to see animation.

## Configure Survey Animation

Animation effects are configured with CSS properties (<a href="https://developer.mozilla.org/en-US/docs/Web/CSS/transition" target="_blank"><code>transition</code></a>, <a href="https://developer.mozilla.org/en-US/docs/Web/CSS/transform" target="_blank"><code>transform</code></a>, <a href="https://developer.mozilla.org/en-US/docs/Web/CSS/transform-origin" target="_blank"><code>transform-origin</code></a>, and others). Create two or more CSS classes that specify transition rules by which a survey changes its styles. Refer to the `index.css` file for CSS rules used in this demo.

## Apply Animation to Survey Elements

To animate elements on a certain event, you can use <a href="https://developer.mozilla.org/en-US/docs/Web/CSS/Pseudo-classes" target="_blank">pseudo classes</a>, such as `hover` or `active`. However, pseudo classes support only a limited number of events. Alternatively, animation effects can be applied using a JavaScript function.

This demo implements a custom `animate(isShowing)` function that applies and removes CSS classes to and from the survey HTML element based on the passed argument. This function should be called whenever you want to trigger animation. In this demo, animation effects apply when a survey is rendered, when users switch between pages, and when they end the survey. To call the `animate` function in these cases, handle the [`onAfterRenderSurvey`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onAfterRenderSurvey), [`onCurrentPageChanging`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onCurrentPageChanging), [`onCurrentPageChanged`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onCurrentPageChanged), [`onCompleting`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onCompleting), and [`onComplete`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onComplete) events. Note that you need to disable the `options.allow` parameter to cancel switching between pages and survey completion and perform these operations in code after animation has finished. Refer to the JavaScript code to view event handler implementations.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/index.css`

```css
.hidden {
  transition: all 1s ease-in-out;
  transform-origin: left top;
  transform: scaleY(0);
}
 
.visible {
  transform: scaleY(1);
}
```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function animate (isShowing) {
    const element = document.getElementById("surveyElement");
    if (!!element) {
        const classes = element.classList;
        if (!classes.contains("hidden")) {
            classes.add("hidden");
        }
        isShowing ? classes.add("visible") : classes.remove("visible");
    }
}

function showAnimated () { animate(true); }
function hideAnimated () { animate(false); }

var doAnimation = true;
const survey = new Model(json);
survey.onComplete.add((sender, options) => {
    console.log(JSON.stringify(sender.data, null, 3));
});
survey.onAfterRenderSurvey.add(showAnimated);

survey.onCurrentPageChanging.add(function (_, options) {
    if (!doAnimation) return;
    options.allow = false;
    setTimeout(function () {
        doAnimation = false;
        survey.currentPage = options.newCurrentPage;
        doAnimation = true;
    }, 1000);
    hideAnimated();
});

survey.onCurrentPageChanged.add(showAnimated);

survey.onCompleting.add(function (_, options) {
    if (!doAnimation) return;
    options.allow = false;
    setTimeout(function () {
        doAnimation = false;
        survey.doComplete();
        doAnimation = true;
    }, 1000);
    hideAnimated();
});

survey.onComplete.add(showAnimated);

survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {
  "pages": [{
    "name": "page1",
    "elements": [{
      "type": "matrix",
      "name": "qualities",
      "title": "Please indicate if you agree or disagree with the following statements",
      "columns": [{
        "value": 5,
        "text": "Strongly agree"
      }, {
        "value": 4,
        "text": "Agree"
      }, {
        "value": 3,
        "text": "Neutral"
      }, {
        "value": 2,
        "text": "Disagree"
      }, {
        "value": 1,
        "text": "Strongly disagree"
      }],
      "rows": [{
        "value": "affordable",
        "text": "Product is affordable"
      }, {
        "value": "does-what-it-claims",
        "text": "Product does what it claims"
      }, {
        "value": "better-than-others",
        "text": "Product is better than other products on the market"
      },{
        "value": "easy-to-use",
        "text": "Product is easy to use"
      }]
    }]
  }, {
    "name": "page2",
    "elements": [{
      "type": "rating",
      "name": "satisfaction-score",
      "title": "How satisfied are you with our product?",
      "minRateDescription": "Not satisfied",
      "maxRateDescription": "Completely satisfied"
    }, {
      "type": "comment",
      "name": "suggestions",
      "title": "What would make you more satisfied with our product?",
      "maxLength": 300
    }]
  }, {
    "name": "page3",
    "elements": [{
      "type": "radiogroup",
      "name": "price-comparison",
      "title": "Compared to our competitors, do you feel our product is:",
      "choices": [
        "Less expensive",
        "Priced about the same",
        "More expensive",
        "Not sure"
      ]
    }]
  }, {
    "name": "page4",
    "elements": [{
      "type": "text",
      "name": "email",
      "title": "Thank you for taking our survey. Please leave your email address if you would like us to contact you."
    }]
  }]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/add-animation-effects-to-form-elements/angular.md)
- [React](https://surveyjs.io/form-library/examples/add-animation-effects-to-form-elements/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/add-animation-effects-to-form-elements/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/add-animation-effects-to-form-elements/jquery.md)


---
title: Add Animation to Survey Elements
product: Form Library
description: SurveyJS supplies highly customizable editing tools that let you create surveys and forms. Apart from personalized elements, such as a logo, custom survey title, and description, you can enable form animation. Apply motion, fading, sliding, and other types of animation effects to form elements or the entire form. View this free code example for JavaScript to learn more.
framework: Angular
source: https://surveyjs.io/form-library/examples/add-animation-effects-to-form-elements/angular
index: https://surveyjs.io/form-library/examples/overview.md
---

# Add Animation to Survey Elements (Angular)

Form animation refers to the use of dynamic and interactive visual effects and transitions that enhance usability, guide users through a form, and create a more enjoyable form-filling experience. A survey creator can apply motion, fading, sliding, and other types of animation effects to individual form elements or the entire form, as shown in this demo. Switch between survey pages to see animation.

## Configure Survey Animation

Animation effects are configured with CSS properties (<a href="https://developer.mozilla.org/en-US/docs/Web/CSS/transition" target="_blank"><code>transition</code></a>, <a href="https://developer.mozilla.org/en-US/docs/Web/CSS/transform" target="_blank"><code>transform</code></a>, <a href="https://developer.mozilla.org/en-US/docs/Web/CSS/transform-origin" target="_blank"><code>transform-origin</code></a>, and others). Create two or more CSS classes that specify transition rules by which a survey changes its styles. Refer to the `index.css` file for CSS rules used in this demo.

## Apply Animation to Survey Elements

To animate elements on a certain event, you can use <a href="https://developer.mozilla.org/en-US/docs/Web/CSS/Pseudo-classes" target="_blank">pseudo classes</a>, such as `hover` or `active`. However, pseudo classes support only a limited number of events. Alternatively, animation effects can be applied using a JavaScript function.

This demo implements a custom `animate(isShowing)` function that applies and removes CSS classes to and from the survey HTML element based on the passed argument. This function should be called whenever you want to trigger animation. In this demo, animation effects apply when a survey is rendered, when users switch between pages, and when they end the survey. To call the `animate` function in these cases, handle the [`onAfterRenderSurvey`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onAfterRenderSurvey), [`onCurrentPageChanging`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onCurrentPageChanging), [`onCurrentPageChanged`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onCurrentPageChanged), [`onCompleting`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onCompleting), and [`onComplete`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onComplete) events. Note that you need to disable the `options.allow` parameter to cancel switching between pages and survey completion and perform these operations in code after animation has finished. Refer to the JavaScript code to view event handler implementations.

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "pages": [{
    "name": "page1",
    "elements": [{
      "type": "matrix",
      "name": "qualities",
      "title": "Please indicate if you agree or disagree with the following statements",
      "columns": [{
        "value": 5,
        "text": "Strongly agree"
      }, {
        "value": 4,
        "text": "Agree"
      }, {
        "value": 3,
        "text": "Neutral"
      }, {
        "value": 2,
        "text": "Disagree"
      }, {
        "value": 1,
        "text": "Strongly disagree"
      }],
      "rows": [{
        "value": "affordable",
        "text": "Product is affordable"
      }, {
        "value": "does-what-it-claims",
        "text": "Product does what it claims"
      }, {
        "value": "better-than-others",
        "text": "Product is better than other products on the market"
      },{
        "value": "easy-to-use",
        "text": "Product is easy to use"
      }]
    }]
  }, {
    "name": "page2",
    "elements": [{
      "type": "rating",
      "name": "satisfaction-score",
      "title": "How satisfied are you with our product?",
      "minRateDescription": "Not satisfied",
      "maxRateDescription": "Completely satisfied"
    }, {
      "type": "comment",
      "name": "suggestions",
      "title": "What would make you more satisfied with our product?",
      "maxLength": 300
    }]
  }, {
    "name": "page3",
    "elements": [{
      "type": "radiogroup",
      "name": "price-comparison",
      "title": "Compared to our competitors, do you feel our product is:",
      "choices": [
        "Less expensive",
        "Priced about the same",
        "More expensive",
        "Not sure"
      ]
    }]
  }, {
    "name": "page4",
    "elements": [{
      "type": "text",
      "name": "email",
      "title": "Thank you for taking our survey. Please leave your email address if you would like us to contact you."
    }]
  }]
};
```

### `src/app/components/survey.component.css`

```css
.hidden {
  transition: all 1s ease-in-out;
  transform-origin: left top;
  transform: scaleY(0);
}
 
.visible {
  transform: scaleY(1);
}
```

### `src/app/components/survey.component.html`

```html
<survey [model]="model" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; height:100%"></survey>
```

### `src/app/components/survey.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { json } from "./json";
import "./survey.component.css";
import "survey-core/survey-core.min.css";

function animate (isShowing) {
    const element = document.getElementById("surveyElement");
    if (!!element) {
        const classes = element.classList;
        if (!classes.contains("hidden")) {
            classes.add("hidden");
        }
        isShowing ? classes.add("visible") : classes.remove("visible");
    }
}

function showAnimated () { animate(true); }
function hideAnimated () { animate(false); }

var doAnimation = true;
@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./survey.component.html",
    styleUrls: ["./survey.component.css"]
})
export class SurveyComponent implements OnInit {
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        survey.onAfterRenderSurvey.add(showAnimated);
        
        survey.onCurrentPageChanging.add(function (_, options) {
            if (!doAnimation) return;
            options.allow = false;
            setTimeout(function () {
                doAnimation = false;
                survey.currentPage = options.newCurrentPage;
                doAnimation = true;
            }, 1000);
            hideAnimated();
        });
        
        survey.onCurrentPageChanged.add(showAnimated);
        
        survey.onCompleting.add(function (_, options) {
            if (!doAnimation) return;
            options.allow = false;
            setTimeout(function () {
                doAnimation = false;
                survey.doComplete();
                doAnimation = true;
            }, 1000);
            hideAnimated();
        });
        
        survey.onComplete.add(showAnimated);
        survey.onComplete.add((sender, options) => {
            console.log(JSON.stringify(sender.data, null, 3));
        });
        this.model = survey;
    }
}
```

### `src/app/components/theme.ts`

```ts
export const themeJson = {};
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyComponent } from "./components/survey.component";

@NgModule({
    declarations: [AppComponent, SurveyComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
.hidden {
  transition: all 1s ease-in-out;
  transform-origin: left top;
  transform: scaleY(0);
}
 
.visible {
  transform: scaleY(1);
}
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/form-library/examples/add-animation-effects-to-form-elements/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/add-animation-effects-to-form-elements/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/add-animation-effects-to-form-elements/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/add-animation-effects-to-form-elements/vanillajs.md)


---
title: Add Animation to Survey Elements
product: Form Library
description: SurveyJS supplies highly customizable editing tools that let you create surveys and forms. Apart from personalized elements, such as a logo, custom survey title, and description, you can enable form animation. Apply motion, fading, sliding, and other types of animation effects to form elements or the entire form. View this free code example for JavaScript to learn more.
framework: React
source: https://surveyjs.io/form-library/examples/add-animation-effects-to-form-elements/reactjs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Add Animation to Survey Elements (React)

Form animation refers to the use of dynamic and interactive visual effects and transitions that enhance usability, guide users through a form, and create a more enjoyable form-filling experience. A survey creator can apply motion, fading, sliding, and other types of animation effects to individual form elements or the entire form, as shown in this demo. Switch between survey pages to see animation.

## Configure Survey Animation

Animation effects are configured with CSS properties (<a href="https://developer.mozilla.org/en-US/docs/Web/CSS/transition" target="_blank"><code>transition</code></a>, <a href="https://developer.mozilla.org/en-US/docs/Web/CSS/transform" target="_blank"><code>transform</code></a>, <a href="https://developer.mozilla.org/en-US/docs/Web/CSS/transform-origin" target="_blank"><code>transform-origin</code></a>, and others). Create two or more CSS classes that specify transition rules by which a survey changes its styles. Refer to the `index.css` file for CSS rules used in this demo.

## Apply Animation to Survey Elements

To animate elements on a certain event, you can use <a href="https://developer.mozilla.org/en-US/docs/Web/CSS/Pseudo-classes" target="_blank">pseudo classes</a>, such as `hover` or `active`. However, pseudo classes support only a limited number of events. Alternatively, animation effects can be applied using a JavaScript function.

This demo implements a custom `animate(isShowing)` function that applies and removes CSS classes to and from the survey HTML element based on the passed argument. This function should be called whenever you want to trigger animation. In this demo, animation effects apply when a survey is rendered, when users switch between pages, and when they end the survey. To call the `animate` function in these cases, handle the [`onAfterRenderSurvey`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onAfterRenderSurvey), [`onCurrentPageChanging`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onCurrentPageChanging), [`onCurrentPageChanged`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onCurrentPageChanged), [`onCompleting`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onCompleting), and [`onComplete`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onComplete) events. Note that you need to disable the `options.allow` parameter to cancel switching between pages and survey completion and perform these operations in code after animation has finished. Refer to the JavaScript code to view event handler implementations.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/SurveyComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function animate (isShowing) {
    const element = document.getElementById("surveyElement");
    if (!!element) {
        const classes = element.classList;
        if (!classes.contains("hidden")) {
            classes.add("hidden");
        }
        isShowing ? classes.add("visible") : classes.remove("visible");
    }
}

function showAnimated () { animate(true); }
function hideAnimated () { animate(false); }

var doAnimation = true;
function SurveyComponent() {
    const survey = new Model(json);
    survey.onComplete.add((sender, options) => {
        console.log(JSON.stringify(sender.data, null, 3));
    });
    survey.onAfterRenderSurvey.add(showAnimated);
    
    survey.onCurrentPageChanging.add(function (_, options) {
        if (!doAnimation) return;
        options.allow = false;
        setTimeout(function () {
            doAnimation = false;
            survey.currentPage = options.newCurrentPage;
            doAnimation = true;
        }, 1000);
        hideAnimated();
    });
    
    survey.onCurrentPageChanged.add(showAnimated);
    
    survey.onCompleting.add(function (_, options) {
        if (!doAnimation) return;
        options.allow = false;
        setTimeout(function () {
            doAnimation = false;
            survey.doComplete();
            doAnimation = true;
        }, 1000);
        hideAnimated();
    });
    
    survey.onComplete.add(showAnimated);
    return (<Survey model={survey} />);
}

export default SurveyComponent;
```

### `src/index.css`

```css
.hidden {
  transition: all 1s ease-in-out;
  transform-origin: left top;
  transform: scaleY(0);
}
 
.visible {
  transform: scaleY(1);
}
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyComponent from "./SurveyComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyComponent />);
```

### `src/json.js`

```js
export const json = {
  "pages": [{
    "name": "page1",
    "elements": [{
      "type": "matrix",
      "name": "qualities",
      "title": "Please indicate if you agree or disagree with the following statements",
      "columns": [{
        "value": 5,
        "text": "Strongly agree"
      }, {
        "value": 4,
        "text": "Agree"
      }, {
        "value": 3,
        "text": "Neutral"
      }, {
        "value": 2,
        "text": "Disagree"
      }, {
        "value": 1,
        "text": "Strongly disagree"
      }],
      "rows": [{
        "value": "affordable",
        "text": "Product is affordable"
      }, {
        "value": "does-what-it-claims",
        "text": "Product does what it claims"
      }, {
        "value": "better-than-others",
        "text": "Product is better than other products on the market"
      },{
        "value": "easy-to-use",
        "text": "Product is easy to use"
      }]
    }]
  }, {
    "name": "page2",
    "elements": [{
      "type": "rating",
      "name": "satisfaction-score",
      "title": "How satisfied are you with our product?",
      "minRateDescription": "Not satisfied",
      "maxRateDescription": "Completely satisfied"
    }, {
      "type": "comment",
      "name": "suggestions",
      "title": "What would make you more satisfied with our product?",
      "maxLength": 300
    }]
  }, {
    "name": "page3",
    "elements": [{
      "type": "radiogroup",
      "name": "price-comparison",
      "title": "Compared to our competitors, do you feel our product is:",
      "choices": [
        "Less expensive",
        "Priced about the same",
        "More expensive",
        "Not sure"
      ]
    }]
  }, {
    "name": "page4",
    "elements": [{
      "type": "text",
      "name": "email",
      "title": "Thank you for taking our survey. Please leave your email address if you would like us to contact you."
    }]
  }]
};
```

### `src/theme.js`

```js
export const themeJson = {};
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/add-animation-effects-to-form-elements/angular.md)
- [Vue 3](https://surveyjs.io/form-library/examples/add-animation-effects-to-form-elements/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/add-animation-effects-to-form-elements/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/add-animation-effects-to-form-elements/vanillajs.md)
